# This file was generated by symflow CLI vSYM_TEMPLATE_VAR_SYMFLOW_VERSION on SYM_TEMPLATE_VAR_GENERATION_TIME UTC.
# No changes to this file are required to start managing your AWS IAM access with Sym.
# Modify this file to customize your AWS IAM access management, or add more AWS IAM Groups to be managed.

## An AWS IAM Group that grants escalated permissions
resource "aws_iam_group" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_group" {
  name = "SYM_TEMPLATE_VAR_FLOW_NAME-SYM_TEMPLATE_VAR_IAM_ROLE_NAME"
  path = "/sym/"
}

## Attach the managed IAM Policy to the IAM Group
resource "aws_iam_group_policy_attachment" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_policy_attachment" {
  group      = aws_iam_group.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_group.id
  policy_arn = "SYM_TEMPLATE_VAR_IAM_ROLE_ARN"
}

############ IAM Strategy Setup ##############

# A target AWS IAM Group that your Sym Strategy can manage access to
resource "sym_target" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_group" {
  type = "aws_iam_group"

  # Your AWS IAM Group.
  # Users in this group are given permissions to access SYM_TEMPLATE_VAR_IAM_ROLE_NAME
  name  = aws_iam_group.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_group.name
  label = "SYM_TEMPLATE_VAR_IAM_ROLE_NAME"

  settings = {
    # `type=aws_iam_group` sym_targets have a required setting `iam_group`,
    # which must be the name of the IAM Group the user will be added to.
    iam_group = aws_iam_group.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_group.name
  }
}

# The Strategy your Flow uses to escalate to AWS IAM Groups
resource "sym_strategy" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_aws_iam" {
  type           = "aws_iam"
  name           = "SYM_TEMPLATE_VAR_FLOW_NAME-aws-iam-strategy"
  integration_id = sym_integration.aws_iam_context.id

  # This must be a list of `aws_iam_group` sym_targets that users can request to be escalated to
  targets = [sym_target.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_escalated_group.id]
}


resource "sym_flow" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_aws_iam" {
  name  = "SYM_TEMPLATE_VAR_FLOW_NAME-aws-iam"
  label = "AWS IAM Group Access"

  implementation = "${path.module}/impls/aws_iam_SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_impl.py"
  environment_id = sym_environment.this.id

  params {
    # By specifying a strategy, this Flow will now be able to manage access (escalate/de-escalate)
    # to the targets specified in the `sym_strategy` resource.
    strategy_id = sym_strategy.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_aws_iam.id

    # Each prompt_field defines a custom form field for the Slack modal that
    # requesters fill out to make their requests.
    prompt_field {
      name     = "reason"
      label    = "Why do you need access?"
      type     = "string"
      required = true
    }

    prompt_field {
      name           = "duration"
      type           = "duration"
      allowed_values = ["30m", "1h"]
      required       = true
    }
  }
}
