# This file was generated by symflow CLI vSYM_TEMPLATE_VAR_SYMFLOW_VERSION on SYM_TEMPLATE_VAR_GENERATION_TIME UTC.
# No changes to this file are required to start managing your AWS Lambda access with Sym.
# Modify this file to customize your AWS Lambda access management (e.g. add more prompt_fields to ask your users for
# more input values).


# This module defines and deploys an AWS Lambda to your AWS account. Its source code can
# be found in the `SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_src` directory. By default,
# it does nothing except return a message saying that it was invoked successfully.
module "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_function" {
  source  = "terraform-aws-modules/lambda/aws"
  version = "~> 4.0.0"

  function_name = "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME"
  description   = "A Lambda to be invoked on escalate and de-escalate Sym events"
  handler       = "handler.lambda_handler"
  runtime       = "python3.8"

  source_path = "${path.module}/SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_src"
}

# This module defines the AWS IAM Resources that enable the Sym Runtime to invoke your
# AWS Lambda function defined above.
module "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_connector" {
  source  = "symopsio/lambda-connector/aws"
  version = ">= 1.0.0"

  environment = "SYM_TEMPLATE_VAR_FLOW_NAME"
  lambda_arns = [module.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_function.lambda_function_arn]

  # The aws_iam_role.sym_runtime_connector_role resource is defined in `runtime.tf`.
  runtime_role_arns = [aws_iam_role.sym_runtime_connector_role.arn]
}

# This Integration provides your Strategy the permissions needed to invoke your AWS Lambda.
# It points to to the AWS IAM resources created by the `SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_connector` module.
resource "sym_integration" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_context" {
  type = "permission_context"
  name = "SYM_TEMPLATE_VAR_FLOW_NAME-lambda-context"

  external_id = module.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_connector.settings.account_id
  settings    = module.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_connector.settings
}

############ AWS Lambda Strategy Setup ##############

# A target AWS Lambda that will be invoked on escalate and de-escalate Sym events.
resource "sym_target" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_function" {
  type = "aws_lambda_function"
  name = "SYM_TEMPLATE_VAR_FLOW_NAME-lambda"

  settings = {
    # `type=aws_lambda_function` sym_targets have a required setting `arn`,
    # which must be the ARN of the AWS Lambda that will be invoked on escalate and de-escalate.
    arn = module.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_function.lambda_function_arn
  }
}

# The Strategy your Flow uses to manage access.
resource "sym_strategy" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda" {
  type = "aws_lambda"
  name = "SYM_TEMPLATE_VAR_FLOW_NAME-lambda-strategy"

  integration_id = sym_integration.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_context.id
  targets        = [sym_target.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda_function.id]
}

# A Sym Flow that executes an AWS Lambda on escalate and de-escalate Sym events.
resource "sym_flow" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda" {
  name = "SYM_TEMPLATE_VAR_FLOW_NAME-lambda"

  implementation = "${path.module}/impls/aws_lambda_SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_impl.py"

  # The sym_environment resource is defined in `environment.tf`.
  environment_id = sym_environment.this.id

  params {
    # By specifying a strategy, this Flow will now be able to manage access (escalate/de-escalate)
    # to the Targets specified in the `sym_strategy` resource.
    strategy_id = sym_strategy.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_lambda.id

    # Each prompt_field defines a custom form field for the Slack modal that
    # requesters fill out to make their requests.
    prompt_field {
      name     = "reason"
      label    = "Why do you need access?"
      type     = "string"
      required = true
    }

    prompt_field {
      name           = "duration"
      type           = "duration"
      allowed_values = ["30m", "1h"]
      required       = true
    }
  }
}
